import java.io.BufferedWriter;
import java.io.DataOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStream;
import java.util.ArrayList;
import java.util.Date;
import java.util.Iterator;
import java.util.Random;
import java.util.zip.ZipEntry;
import java.util.zip.ZipOutputStream;

import Rabin.fingerprint.Fingerprint;
import Rabin.handprint.FingerFactory;
import Rabin.handprint.HandPrint;
import Rabin.polynomial.Polynomial;


public class MainProgram {

	static boolean debugMode = false;
	public static int counter;
	public static int threadNum = 4;
	public static int queueSize = 10000;
	public static int sleepTime = 15000;
	public static ArrayList<String> alFileAddress = new ArrayList<String>();
	public static int totalNumberofFiles = 0;
	
	public static CalcFingerPrintOfFiles[] calcFingerPrintOfFiles;
	public static Thread [] threads;
	public static GetListOfFiles getListOfFiles = new GetListOfFiles();
	public static Thread thread_getFile;
	public static DataOutputStream[] outLogger;
	public static int progress = 0;
//	public static BufferedWriter out_debug;
	public static void main(String[] args) {
		try{
			
			threadNum = Runtime.getRuntime().availableProcessors();
			outLogger = new DataOutputStream[threadNum];
			calcFingerPrintOfFiles = calcFingerPrintOfFiles = new CalcFingerPrintOfFiles[threadNum];
			threads = new Thread[threadNum];
			
			//*************get disk quota
			long usedSpaceOnDisk = getUsedSpaceOnDisk();
			long proccessedDataSize =0;
			int percentageDataSize =0, percentageDataSize_previousValue =0;
						
	//		out_debug = new BufferedWriter(new FileWriter("debug.txt"));
			
			System.out.println(new Date());
			long t1 = System.currentTimeMillis();
			//String seperator = System.getProperties().getProperty("file.separator");
			
			//************************ create the workers
			for (int i = 0; i < threadNum; i++) {
				outLogger[i] = new DataOutputStream(new FileOutputStream("out_"+ i + ".txt"));
				calcFingerPrintOfFiles[i] = new CalcFingerPrintOfFiles(i, outLogger[i]);
			}

			//********* get the list of files in the directory
			thread_getFile = new Thread(getListOfFiles);
			thread_getFile.start();
			Thread.currentThread().sleep(sleepTime); 
			thread_getFile.suspend();
			int counter_thread =0;
			
			boolean stop = false;
			while(getListOfFiles.alFileAddress.size() !=0){
			
				//push data to the workers
				for (int i = 0; i < threadNum; i++) {
					
					if(calcFingerPrintOfFiles[i].fileAddress.size() ==0){
						fillQueueOfWorker(calcFingerPrintOfFiles[i]);
						counter_thread++;
						if(debugMode)
							System.out.println("thread num: " + counter_thread +new Date());
						proccessedDataSize += calcFingerPrintOfFiles[i].processedDataSize;
						calcFingerPrintOfFiles[i].processedDataSize =0; //reset estimation of processed data
						threads[i] = new Thread(calcFingerPrintOfFiles[i]);
						threads[i].start();
					}
				}
				
				//if there is more files in the system, it addes them to the main queue
				if (!stop) {
					int mainQueueFile = getListOfFiles.alFileAddress.size();
					// get list of new files
					if (getListOfFiles.alFileAddress.size() < 100000) {
						thread_getFile.resume();
						Thread.currentThread().sleep(sleepTime);
						thread_getFile.suspend();
						System.gc();
						for (int i = 0; i < outLogger.length; i++) {
							outLogger[i].flush();
						}
					}
				//	if (mainQueueFile == getListOfFiles.alFileAddress.size())
					if(!thread_getFile.isAlive())
						stop = true;
				}
				
				// there no file to add to the main list, so it waits to assign the reset of the files in the main queue to the workers
				if(getListOfFiles.alFileAddress.size() !=0 && stop)
					Thread.currentThread().sleep(10000);
				percentageDataSize = (int)(proccessedDataSize *100 / usedSpaceOnDisk);
				if(percentageDataSize != percentageDataSize_previousValue){
					System.out.println( percentageDataSize+ "% is completed.");
					percentageDataSize_previousValue = percentageDataSize;
				}
				
			}
			
			for (int i = 0; i < threadNum; i++) {
				threads[i].join();
			}
			
	//		Thread.currentThread().join();
//			
			//***************
			
			for (int i = 0; i < outLogger.length; i++) {
				outLogger[i].close();
			}
			long t2= System.currentTimeMillis();
			System.out.println(new Date());
			System.out.println((t2-t1));
			
			// Create a buffer for reading the files
			byte[] buf = new byte[1024];

			// ************************* Create the ZIP file 
			String outFilename = "outfile" + (new Random()).nextInt() + ".zip";
			ZipOutputStream out = new ZipOutputStream(new FileOutputStream(outFilename));
			out.setLevel(9);
			// Compress the files
			for (int i = 0; i < threadNum; i++) {
				FileInputStream in = new FileInputStream("out_"+ i + ".txt");

				// Add ZIP entry to output stream.
				out.putNextEntry(new ZipEntry("out_"+ i + ".txt"));

				// Transfer bytes from the file to the ZIP file
				int len;
				while ((len = in.read(buf)) > 0) {
					out.write(buf, 0, len);
				}

				// Complete the entry
				out.closeEntry();
				in.close();
			}
			// ************** os info
			String os_info_file = "os_info";
			out.putNextEntry(new ZipEntry(os_info_file));
			String osInfo = System.getProperty("os.name") + "\n"+ System.getProperty("os.arch") + "\n" + System.getProperty("os.version") + "\ntotal number of files:" + totalNumberofFiles;
			out.write(osInfo.getBytes(), 0, osInfo.getBytes().length);
			out.closeEntry();
			// Complete the ZIP file

			out.close();
		
		}catch (Exception e) {
			BLLogger.logData(e.getMessage());
		}
		
	}
	
	private static long getUsedSpaceOnDisk() {
		Long usedSpace = 0L;
		File[] roots = File.listRoots();
		for (int i = 0; i < roots.length; i++) {
			usedSpace += (roots[i].getTotalSpace() - roots[i].getFreeSpace());
		}
		return usedSpace;
	}

	private static void fillQueueOfWorker(
			CalcFingerPrintOfFiles calcFP) {
		int toIndex = Math.min(10000, getListOfFiles.alFileAddress.size());
		
		//calcFP.fileAddress = getListOfFiles.alFileAddress.subList(0, toIndex);
		//calcFP.fileAddress = new Vector<String>();
		for (int i = 0; i < toIndex; i++) {
			calcFP.fileAddress.add(getListOfFiles.alFileAddress.get(i));
		}	
		
		getListOfFiles.alFileAddress.subList(0, toIndex).clear();
//		for (int i = 0; i < toIndex; i++) {
//			getListOfFiles.alFileAddress.remove(i);
//		}	
	}

	public static void fingerprintFile( String filename, Fingerprint<?> rabin ) throws Exception {
		rabin.reset();
		long start = System.currentTimeMillis();
		InputStream stream = new FileInputStream( filename );
		int next;
		try {
			// buffering data like this is MUCH faster
			byte[] data = new byte[4096];
			while ( ( next = stream.read( data ) ) >= 0 ) {
				for ( int i = 0; i < next; i++ ) {
					rabin.pushByte( data[i] );
				}
			}
		} finally {
			stream.close();
		}

		long end = System.currentTimeMillis();
		System.out.println( filename + ": " + rabin.toString() + " in " + (end - start)/1000.0 + " seconds");

	}
	
	private static void testChunkingFiles() throws IOException {
		Polynomial p = Polynomial.createIrreducible( 53 );
		FingerFactory factory = new FingerFactory( p, FingerFactory.WINDOW_SIZE );

		HandPrint hand1 = new HandPrint( new File( "input/1.avi" ), factory );
		HandPrint hand2 = new HandPrint( new File( "input/2.avi" ), factory );
		HandPrint hand3 = new HandPrint( new File( "input/3.avi" ), factory );

		
//		System.out.println( "thumb 1: " + hand1.getPalm() );
//		System.out.println( "thumb 2: " + hand2.getPalm() );
//		System.out.println( "thumb 3: " + hand3.getPalm() );

//		System.out.println( "|chunks| 1: " + hand1.getFingerCount() );
//		System.out.println( "|chunks| 2: " + hand2.getFingerCount() );
//		System.out.println( "|chunks| 3: " + hand3.getFingerCount() );

//		System.out.println( "hand 1: " + hand1.toString() );
//		System.out.println( "hand 2: " + hand2.toString() );
//		System.out.println( "hand 3: " + hand3.toString() );

//		double sim12 = 100.0 * HandprintUtils.getSimilarity( hand1, hand2 );
//		double sim13 = 100.0 * HandprintUtils.getSimilarity( hand1, hand3 );
//		double sim23 = 100.0 * HandprintUtils.getSimilarity( hand2, hand3 );

//		System.out.println( "1->2: " + HandprintUtils.countOverlap( hand1, hand2 ) + " (" + sim12 + "%)" );
//		System.out.println( "1->3: " + HandprintUtils.countOverlap( hand1, hand3 ) + " (" + sim13 + "%)" );
//		System.out.println( "2->3: " + HandprintUtils.countOverlap( hand2, hand3 ) + " (" + sim23 + "%)" );
//		
		
		
		//BidiSortedMap<Long, Interval> hand = hand1.getHandFingers();
		
		final Iterator<Long> ia = hand3.getAllFingers().keyList().iterator();
		
		while(ia.hasNext()){
			System.out.println(ia.next());
		}
//		for (Long key: hand.keyList()) {
//			System.out.println(hand.getValueOf(key));
//		}
	}

	
}



//for (Iterator iterator = files.iterator(); iterator.hasNext();) {
//File file = (File) iterator.next();
//getFingerPrints(file);
//}

// generate random irreducible polynomial
//Polynomial p = Polynomial.createIrreducible( 31 );
//
//boolean usePolynomials = true;
//// choose a fingerprinting method
//final Fingerprint<?> rabin;
//if ( usePolynomials ) {
//rabin = new RabinFingerprintPolynomial( p );
//} else {
//rabin = new RabinFingerprintLong( p );
//}
//
//// time fingerprints
//System.out.println( "fingerprinting:" );
////while(true){
////fingerprintFile( "input/lap.pdf", rabin );
////}
//fingerprintFile( "input/1.avi", rabin );
